;========================================================
; Atomic Muncher
; By Erik557 and MarioFanGamer
;
; Description: A muncher that acts like a falling spike
; but that explodes in ground contact.
;
; Uses first extra bit: YES
; When set, it'll rise instead of falling.
;========================================================

tilemap:
        db $EE,$EC
coin_x_speed:
        db -$06,$06

!coin_tile      = $E8
!air_tile       = $0025
!explosion_time = $1F
!coin_y_speed   = $E8

;=================================
; INIT and MAIN Wrappers
;=================================

print "MAIN ",pc
       PHB
       PHK
       PLB
       JSR troll_coin
       PLB
print "INIT ",pc
       RTL

;========================
; Main routine
;========================

troll_coin:
        LDA !C2,x
        BEQ +
        LDA !1540,x
        BNE explode
        BRA fly
+       %SpriteBlockPos()
        STZ $1933|!Base2
        %GetMap16()
        XBA
        TYA
        XBA
        REP #$20
        CMP #!air_tile
        SEP #$20
        BNE coin_activated
        STZ !14C8,x
        RTS

explode_prior:
        ASL !167A,x
        LSR !167A,x
        LDA #$0C
        STA !154C,x
        LDA #$08
        STA $1DF9|!Base2
        LDA #!explosion_time
        STA !1540,x
explode:
        PEA.w ($02)|(troll_coin>>16<<8)
        PLB
        JSL $028086|!BankB
        PLB
        RTS

locked_sprites:
        LDA !1540,x
        BNE explode
main_return:
        RTS
coin_activated:
        JSR draw_sprite
        LDA $9D
        BNE locked_sprites
        %SubOffScreen()
        JSL $01A7DC|!BankB
        BCC main_return
        INC !C2,x
        %SpriteBlockPos()
        REP #$20
        LDA.w #!air_tile
        %ChangeMap16()
        SEP #$20
check_behavior:
        LDA !7FAB10,x
        AND #$04
        BEQ explode_prior
fly:
        INC !1570,x
        JSR draw_sprite
        REP #$20
        LDA $00
        STA $0300|!Base2,y
        SEP #$20
        LDA #!coin_tile
        STA $0302|!Base2,y
        LDA !15F6,x
        ORA $64
        STA $0303|!Base2,y
        LDY #$02
        TDC
        JSL $01B7B3|!BankB
        PHK
        PEA.w .wings_return-1
        PEA.w ($01)|(troll_coin>>16<<8)
        PLB
        PEA $801F
        JML $019E95|!BankB
.wings_return
        JSL $01801A|!BankB
        JSL $018022|!BankB
        LDA !1594,x
        BNE main_return
        INC !1594,x
        LDA #$03
        STA $1DFC|!Base2
        %SubHorzPos()
        LDA coin_x_speed,y
        STA !B6,x
        LDA #!coin_y_speed
        STA !AA,x
        RTS

;   this wouldn't be needed but, if somehow triggered offscreen this'd crash. thank you, getdrawinfo returning.
draw_sprite:
        %GetDrawInfo()
        RTS

